/* jshint globalstrict:true */
'use strict';

const ICONS_CONTAINER_ID = 'locrmaps-icons';

document.addEventListener('DOMContentLoaded', function() {
    let iconsElement;

    const locrmapsIconsQuerySelector = document.getElementById('locrmaps-icons-query-selector');
    if (locrmapsIconsQuerySelector instanceof HTMLInputElement && locrmapsIconsQuerySelector.value) {
        iconsElement = document.querySelector(locrmapsIconsQuerySelector.value);
    }
    if (!iconsElement) {
        iconsElement = document.getElementById(ICONS_CONTAINER_ID);
    }

    if (iconsElement instanceof HTMLSelectElement) {
        iconsElement.addEventListener('change', function(event) {
            if (!(event.target instanceof HTMLSelectElement)) {
                return;
            }

            document.dispatchEvent(new CustomEvent('locr.locrmaps.set-poi', { detail: { icon: event.target.value, draggable: true } }));
        });

        if (iconsElement.value) {
            document.dispatchEvent(new CustomEvent('locr.locrmaps.set-poi', { detail: { icon: iconsElement.value, draggable: true } }));

            if (wp?.hooks) {
                wp.hooks.addAction(
                    'locrMAPSInitialFitBounds',
                    'locr/locrmaps',
                    () => document.dispatchEvent(new CustomEvent('locr.locrmaps.set-poi', { detail: { icon: iconsElement.value, draggable: true } }))
                );
                wp.hooks.addAction(
                    'locrMAPSInitialSetView',
                    'locr/locrmaps',
                    () => document.dispatchEvent(new CustomEvent('locr.locrmaps.set-poi', { detail: { icon: iconsElement.value, draggable: true } }))
                );
            }
        }
    }
});
